
#include <math.h>
#include "util.h"
#include <stdlib.h>

extern int no_hid, no_inp, no_tar, no_wts;
extern real *w, **wi, **wd, **wo, *hidden, *output;
extern real prior(real *dw);

void net(real *in, real *out)          /* compute network output given input */
{
  int  i, j;
  real x, *tmp;

  for (i=0; i<no_hid; i++) {             /* compute activity of hidden units */
    tmp = wi[i];
    x = tmp[no_inp];                                          /* hidden bias */
    for (j=0; j<no_inp; j++) x += in[j]*tmp[j];
    hidden[i] = tanh(x);
  }

  for (i=0; i<no_tar; i++) {           /* compute activities of output units */
    tmp = wo[i];
    x = tmp[no_hid];                                          /* output bias */
    for (j=0; j<no_hid; j++) x += hidden[j]*tmp[j];
    tmp = wd[i];
    for (j=0; j<no_inp; j++) x += in[j]*tmp[j];            /* direct weights */
    out[i] = x;
  }
}     

real cost(ex, wc)     /* calc. error on examples, including penalty iff wc=1 */
  struct exampleset ex;
  int    wc;
{
  int  i, j;
  real x, *tmp, e = 0.0;

  for (i=0; i<ex.num; i++) {
    net(ex.inp[i], output);
    tmp = ex.tar[i];
    for (j=0; j<no_tar; j++) {
      x = output[j] - tmp[j];
      e += x*x;
    }
  }
  x = 0.0; if (wc == 1) x = prior(NULL);
  return (e+x)/ex.num;
}
